<html>
<head>
<title>OgreGLSLLinkProgramManager.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_4557aaee8cf510d5b035fe0c2c5dd433.html">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_81e02400f093837e2a11409f96e5fd4f.html">GLSL</a>      </li>
      <li class="navelem"><a class="el" href="dir_2fa9b21d57931d849b3ca4a2f6225bef.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLSLLinkProgramManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLSLLinkProgramManager_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __GLSLLinkProgramManager_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __GLSLLinkProgramManager_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLPrerequisites_8h.html">OgreGLPrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLSLExtSupport_8h.html">OgreGLSLExtSupport.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLSLLinkProgram_8h.html">OgreGLSLLinkProgram.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00052"></a><a class="code" href="classOgre_1_1GLSLLinkProgramManager.html">00052</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLSLLinkProgramManager.html" title="Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL has one progr...">GLSLLinkProgramManager</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;GLSLLinkProgramManager&gt;
<a name="l00053"></a>00053     {
<a name="l00054"></a>00054 
<a name="l00055"></a>00055     <span class="keyword">private</span>:
<a name="l00056"></a>00056     
<a name="l00057"></a><a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#a72b9d32bf15126b4368cb0858297ad47">00057</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;uint64, GLSLLinkProgram*&gt;::type</a> <a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#a72b9d32bf15126b4368cb0858297ad47">LinkProgramMap</a>;
<a name="l00058"></a><a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#a5d934f329bb59c6d8161d87bee02c991">00058</a>         <span class="keyword">typedef</span> LinkProgramMap::iterator <a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#a5d934f329bb59c6d8161d87bee02c991">LinkProgramIterator</a>;
<a name="l00059"></a>00059 
<a name="l00061"></a><a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#a31eb5bea7006d830b5f98cc9f334511f">00061</a>         <a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#a72b9d32bf15126b4368cb0858297ad47">LinkProgramMap</a> <a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#a31eb5bea7006d830b5f98cc9f334511f" title="container holding previously created program objects">mLinkPrograms</a>; 
<a name="l00062"></a>00062 
<a name="l00064"></a><a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#accc8e3da6656fc3378d5deeb82aadc48">00064</a>         <a class="code" href="classOgre_1_1GLSLGpuProgram.html" title="GLSL low level compiled shader object - this class is used to get at the linked program object and pr...">GLSLGpuProgram</a>* <a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#accc8e3da6656fc3378d5deeb82aadc48" title="active objects defining the active rendering gpu state">mActiveVertexGpuProgram</a>;
<a name="l00065"></a><a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#aabf8c925ca4474e1523ebb6f393dcb64">00065</a>         <a class="code" href="classOgre_1_1GLSLGpuProgram.html" title="GLSL low level compiled shader object - this class is used to get at the linked program object and pr...">GLSLGpuProgram</a>* <a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#aabf8c925ca4474e1523ebb6f393dcb64">mActiveGeometryGpuProgram</a>;
<a name="l00066"></a><a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#a19e4eaaf2edebbe6097b5976ded7ae09">00066</a>         <a class="code" href="classOgre_1_1GLSLGpuProgram.html" title="GLSL low level compiled shader object - this class is used to get at the linked program object and pr...">GLSLGpuProgram</a>* <a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#a19e4eaaf2edebbe6097b5976ded7ae09">mActiveFragmentGpuProgram</a>;
<a name="l00067"></a><a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#aee6e3ebb3971970af8e2b7099b7d5cee">00067</a>         <a class="code" href="classOgre_1_1GLSLLinkProgram.html" title="C++ encapsulation of GLSL Program Object.">GLSLLinkProgram</a>* <a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#aee6e3ebb3971970af8e2b7099b7d5cee">mActiveLinkProgram</a>;
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#a9f09464371a11c39ae51a42207892160">00069</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, GLenum&gt;::type</a> <a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#a9f09464371a11c39ae51a42207892160">StringToEnumMap</a>;
<a name="l00070"></a><a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#aab4a7fd5ccea9b632513b67c69c16501">00070</a>         <a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#a9f09464371a11c39ae51a42207892160">StringToEnumMap</a> <a class="code" href="classOgre_1_1GLSLLinkProgramManager.html#aab4a7fd5ccea9b632513b67c69c16501">mTypeEnumMap</a>;
<a name="l00071"></a>00071 
<a name="l00073"></a>00073         <span class="keywordtype">void</span> completeDefInfo(GLenum gltype, <a class="code" href="structOgre_1_1GpuConstantDefinition.html" title="Information about predefined program constants.">GpuConstantDefinition</a>&amp; defToUpdate);
<a name="l00075"></a>00075         <span class="keywordtype">bool</span> completeParamSource(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; paramName,
<a name="l00076"></a>00076             <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a>* vertexConstantDefs, 
<a name="l00077"></a>00077             <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a>* geometryConstantDefs,
<a name="l00078"></a>00078             <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a>* fragmentConstantDefs,
<a name="l00079"></a>00079             <a class="code" href="structOgre_1_1GLUniformReference.html" title="Structure used to keep track of named uniforms in the linked program object.">GLUniformReference</a>&amp; refToUpdate);
<a name="l00080"></a>00080 
<a name="l00081"></a>00081     <span class="keyword">public</span>:
<a name="l00082"></a>00082 
<a name="l00083"></a>00083         <a class="code" href="classOgre_1_1GLSLLinkProgramManager.html" title="Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL has one progr...">GLSLLinkProgramManager</a>(<span class="keywordtype">void</span>);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085         ~<a class="code" href="classOgre_1_1GLSLLinkProgramManager.html" title="Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL has one progr...">GLSLLinkProgramManager</a>(<span class="keywordtype">void</span>);
<a name="l00086"></a>00086 
<a name="l00091"></a>00091         <a class="code" href="classOgre_1_1GLSLLinkProgram.html" title="C++ encapsulation of GLSL Program Object.">GLSLLinkProgram</a>* getActiveLinkProgram(<span class="keywordtype">void</span>);
<a name="l00092"></a>00092 
<a name="l00097"></a>00097         <span class="keywordtype">void</span> setActiveFragmentShader(<a class="code" href="classOgre_1_1GLSLGpuProgram.html" title="GLSL low level compiled shader object - this class is used to get at the linked program object and pr...">GLSLGpuProgram</a>* fragmentGpuProgram);
<a name="l00102"></a>00102         <span class="keywordtype">void</span> setActiveGeometryShader(<a class="code" href="classOgre_1_1GLSLGpuProgram.html" title="GLSL low level compiled shader object - this class is used to get at the linked program object and pr...">GLSLGpuProgram</a>* geometryGpuProgram);
<a name="l00107"></a>00107         <span class="keywordtype">void</span> setActiveVertexShader(<a class="code" href="classOgre_1_1GLSLGpuProgram.html" title="GLSL low level compiled shader object - this class is used to get at the linked program object and pr...">GLSLGpuProgram</a>* vertexGpuProgram);
<a name="l00108"></a>00108 
<a name="l00123"></a>00123         <span class="keywordtype">void</span> extractUniforms(GLhandleARB programObject, 
<a name="l00124"></a>00124             <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a>* vertexConstantDefs, 
<a name="l00125"></a>00125             <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a>* geometryConstantDefs,
<a name="l00126"></a>00126             <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a>* fragmentConstantDefs,
<a name="l00127"></a>00127             <a class="code" href="namespaceOgre.html#a24aca8d208dcf62fbe3bee9e759ac73d">GLUniformReferenceList</a>&amp; <a class="code" href="structOgre_1_1list.html">list</a>);
<a name="l00134"></a>00134         <span class="keywordtype">void</span> extractConstantDefs(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; src, <a class="code" href="structOgre_1_1GpuNamedConstants.html" title="Struct collecting together the information for named constants.">GpuNamedConstants</a>&amp; constantDefs, 
<a name="l00135"></a>00135             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename);
<a name="l00136"></a>00136 
<a name="l00137"></a>00137         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GLSLLinkProgramManager.html" title="Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL has one progr...">GLSLLinkProgramManager</a>&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l00138"></a>00138         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GLSLLinkProgramManager.html" title="Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL has one progr...">GLSLLinkProgramManager</a>* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l00139"></a>00139 
<a name="l00140"></a>00140     };
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 }
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="preprocessor">#endif // __GLSLLinkProgramManager_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
